unit Param;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
   Shlobj, ActiveX, ComObj, Registry;

const
  { t@C̃^CX^v }
  ftCreationTime   = 1; // t@C쐬
  ftLastAccessTime = 2; // t@C̃ANZX
  ftLastWriteTime  = 4; // t@CXV

type
  EValueName = class(Exception);

  { SelectFolder() ֐ Windows API SHBrowseForFolder() ɓn }
  { _CAO\ׂ̈̒ǉ }
  PBFFMore = ^TBFFMore;
  TBFFMore = record
    InitPath: PChar; // ItH_
    Left: Integer;   // \鍶 X W
    Top: Integer;    // \鍶 Y W
  end;

  { gq }
  PExtensionRec = ^TExtensionRec;
  TExtensionRec = record
    Extension: String;     // gq
    ExtensionKey: String;  // gq̊i[惌WXgL[
    ExtensionName: String; // gqt@C̈ʌď
    DefaultIcon: String;   // gq̃ACȐݐ
    Command: String;       // t@CJɎsR}h
  end;

  TParameter = class(TComponent)
  private
    { Private 錾 }
    FParams: TStringList; // ep[^̊i[̈
    FDir: String;         // p[^ۑt@CutH_
    FFileName: String;    // p[^ۑt@C
    FExeName: String;     // AvP[V̎st@C
    FDigit: Integer;      // _^ VExtends[] ̗L(3 ` 18)
    function GetParam(Index: Integer): String;
    function GetVString(const Name: String): String;
    function GetVBool(const Name: String): Boolean;
    function GetVInteger(const Name: String): Integer;
    function GetVFontStyle(const Name: String): TFontStyles;
    function GetVExtend(const Name: String): Extended;
    function GetDir: String;
    function GetFileName: String;
    function GetFullName: String;
    function GetExeName: String;
    function GetDigit: Integer;
    procedure SetParam(Index: Integer; const Value: String);
    procedure SetVString(const Name, Value: String);
    procedure SetVBool(const Name: String; Value: Boolean);
    procedure SetVInteger(const Name: String; Value: Integer);
    procedure SetVFontStyle(const Name: String; Value: TFontStyles);
    procedure SetVExtend(const Name: String; Value: Extended);
    procedure SetDir(const Value: String);
    procedure SetFileName(const Value: String);
    procedure SetExeName(const Value: String);
    procedure SetDigit(const Value: Integer);
  protected
    { Protected 錾 }
    function GetCount: Integer; virtual;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Add(const S: String): Integer; virtual;
    function IndexOfName(const Name: String): Integer;
    function CreateShortCut(nFolder: Integer; LinkName: String): Boolean; virtual;
    function DeleteShortCut(nFolder: Integer; LinkName: String): Boolean; virtual;
    procedure Init; virtual;
    procedure Clear;  virtual;
    procedure Insert(Index: Integer; const S: String); virtual;
    procedure Delete(Index: Integer); virtual;
    procedure LoadFromFile; virtual;
    procedure SaveToFile; virtual;
    { vpeB錾 }
    property Params[Index: Integer]: String read GetParam write SetParam;
    property VStrings[const Name: String]: String read GetVString write SetVString;
    property VBools[const Name: String]: Boolean read GetVBool write SetVBool;
    property VIntegers[const Name: String]: Integer read GetVInteger write SetVInteger; default;
    property VFontStyles[const Name: String]: TFontStyles read GetVFontStyle write SetVFontStyle;
    property VExtends[const Name: String]: Extended read GetVExtend write SetVExtend;
  published
    { Published 錾(vpeB錾) }
    property Dir: String read GetDir write SetDir;
    property FileName: String read GetFileName write SetFileName;
    property FullName: String read GetFullName;
    property ExeName: String read GetExeName write SetExeName;
    property Count: Integer read GetCount;
    property Digit: Integer read GetDigit write SetDigit default 15; // 3 ` 18
  end;

function GetSpecialFolder(nFolder: Integer): String;
function CreateShortCutLink(FileName: String; LinkPath: String; LinkName: String): Boolean;
function DeleteShortCutLink(LinkPath: String; LinkName: String): Boolean;
function SelectFolder(hWindow: HWND; Title: String; InitPath: String;
                      Left: Integer; Top:Integer): String;
function BrowseCallBackProc(hWindow: HWND; uMsg: UINT;
                            lp: LPARAM; lpData: LPARAM):Integer; stdcall;
function FileTimeToDateTime(FTime: TFileTime; var DTime: TDateTime): Boolean;
function DateTimeToFileTime(DTime: TDateTime; var FTime: TFileTime): Boolean;
function SetTimeStamp(FileName: String; Stamp: Integer; DTime: TDateTime): Boolean;
function AssociateExists(Extension: String): Boolean;
function AssociateGet(Extension: String; var R: TExtensionRec): Boolean;
function AssociateMake(R: TExtensionRec): Boolean;
function AssociateChange(R: TExtensionRec): Boolean;
function AssociateDelete(Extension: String): Boolean;
function RegDeleteKeyR(Root: HKEY; Key: String): Boolean;
function LongNameToShortName(LongName: String; var ShortName: String): Boolean;
function ShortNameToLongName(ShortName: String; var LongName: String): Boolean;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('ToolBox', [TParameter]);
end;

{ Windows ̓tH_̃tpX CSIDL l擾֐łB}
{ nFolder : Windows ̓tH_\킷 CSIDL l }
{  CSIDL lɂ́Aȉ̗lȂ̂܂B}
{ CSIDL_DESKTOP : fXNgbv }
{ CSIDL_PROGRAMS : vO }
{ CSIDL_STARTUP : X^[gAbv }
{ CSIDL_PERSONAL : }ChLg }
{ CSIDL_FOVORITES : Cɓ }
{ CSIDL_COMMON_PROGRAMS : vO(S[U[) }
{ CSIDL_COMMON_STARTUP : X^[gAbv(S[U[) }
{ CSIDL_COMMON_FAVORITES : Cɓ(S[U[) }
{ ȂACSIDL_* ̊e萔gpꍇ́Auses ߂ ShlObj KvłB}
{ 擾ɐΓtH_̃tpXAs΋󕶎Ԃ܂B}

function GetSpecialFolder(nFolder: Integer): String;
var
  Path: array[0..MAX_PATH] of Char;
  pidl: PItemIDList;
begin
  Result := '';
  pidl := Nil;
  // CSIDLl獀ڎʎq擾
  if SHGetSpecialFolderLocation(0, nFolder, pidl) = NOERROR then
  begin
    // ڎʎqpX擾
    if SHGetPathFromIDList(pidl, Path) = TRUE then
      Result := Path;
    CoTaskMemFree(pidl);
  end;
end;

{ wꏊɃV[gJbg쐬֐łB}
{ FileName : V[gJbg쐬t@C(tpX) }
{ LinkPath : V[gJbg쐬ꏊ(fBNg) }
{ LinkName : V[gJbgɕt閼O }
{ V[gJbg̍쐬ɐ True As False Ԃ܂B}

function CreateShortCutLink(FileName: String; LinkPath: String; LinkName: String): Boolean;
var
  Unknown: IUnknown;
  ShellLink: IShellLink;
  PersistFile: IPersistFile;
  LinkFileName: String;
  wLinkFileName: WideString;
begin
  Result := False;
  if (FileName = '') or (LinkPath = '') or (LinkName = '') then
    Exit;

  //V[gJbgɕt閼O쐬
  LinkFileName := LinkPath;
  if LinkFileName[Length(LinkFileName)] <> '\' then
    LinkFileName := LinkFileName + '\';

  LinkFileName := LinkFileName + LinkName + '.lnk';
  wLinkFileName := LinkFileName;

  Unknown := CreateComObject(CLSID_ShellLink);
  if Assigned(Unknown) then
  begin
    ShellLink := Unknown as IShellLink;
    PersistFile := Unknown as IPersistFile;
    if Assigned(ShellLink) and Assigned(PersistFile) then
    begin
      //N̎w
      ShellLink.SetPath(PChar(FileName));
      ShellLink.SetWorkingDirectory(PChar(ExtractFilePath(FileName)));
      //N쐬
      if PersistFile.Save(PWChar(wLinkFileName), False) = S_OK then
        Result := True;
    end;
  end;
end;

{ wꏊ̃V[gJbg폜֐łB}
{ LinkPath : V[gJbg쐬ꏊ(fBNg) }
{ LinkName : V[gJbgɕtꂽO }
{ V[gJbg̍폜ɐ True As False Ԃ܂B}

function DeleteShortCutLink(LinkPath: String; LinkName: String): Boolean;
var
  LinkFileName: String;
begin
  Result := False;
  if (LinkPath = '') or (LinkName = '') then
    Exit;

  LinkFileName := LinkPath;
  if LinkFileName[Length(LinkFileName)] <> '\' then
    LinkFileName := LinkFileName + '\';

  LinkFileName := LinkFileName + LinkName + '.lnk';
  Result := DeleteFile(LinkFileName);
end;

{ tH_I_CAO\֐łB}
{ hWindow  : _CAO̐eEBhẼnh }
{ Title    : _CAOɕ\^Cg }
{ InitPath : ItH_ }
{ Left     : \鍶 X W }
{ Top      : \鍶 Y WW }
{ ItH_̃tpXԂ܂B}

function SelectFolder(hWindow: HWND; Title: String; InitPath: String;
                      Left: Integer; Top:Integer): String;
var
  BFFM: TBFFMore;
  BI: TBrowseInfo;
  pidlBrowse: PItemIDList;
  Buffer: PChar;
  Malloc: IMalloc;
begin
  Result := '';
  { Get the shell's allocator. }
  if (SHGetMalloc(Malloc) <> NOERROR) or (Malloc = Nil) then
    Exit;

  Buffer := Malloc.Alloc(MAX_PATH);
  try
    { SHBrowseForFolder() API ɓnA_CAO\ׂ̈̒ǉ }
    BFFM.InitPath := PChar(InitPath); // ItH_
    BFFM.Left := Left;                // \鍶 X W
    BFFM.Top := Top;                  // \鍶 Y W

    { fXNgbv[gtH_ɂă}CRs[^IԂɂ }
    { ɂ́Aȉ̗l TBrowseInfo  pidlRoot o Nil ɂƉ\ }
    { ɂȂ܂BႦ΁ACSIDL lgpāA}
    { SHGetSpecialFolderLocation(hWindow, CSIDL_DESKTOP, pidlDialog); }
    { BI.pidlRoot := pidlDialog; }
    { ̗lɂ SHBrowseForFolder() ĂԂƃ[gtH_̓fXNgbv }
    { ɂȂ̂ł}CRs[^͕ԂŃ_CAO\܂B}
    { ́ASHBrowseForFolder() ̎dlł͂ȂƎv܂B}

    BI.hwndOwner := hWindow;
    BI.pidlRoot := Nil;
    BI.pszDisplayName := Buffer;
    BI.lpszTitle := PChar(Title);
    BI.ulFlags := BIF_RETURNONLYFSDIRS;
    BI.lpfn := @BrowseCallBackProc;
    BI.lParam := LPARAM(@BFFM);
    BI.iImage := 0;

    pidlBrowse := SHBrowseForFolder(BI);
    If pidlBrowse <> Nil then
    begin
      SHGetPathFromIDList(pidlBrowse, Buffer);
      Result := Buffer;
      Malloc.Free(pidlBrowse);
    end;
  finally
    Malloc.Free(Buffer);
  end;
end;

{ SelectFolder() Őݒ肷 SHBrowseForFolder() API ̃R[obN֐łB}
{ [U[ڂ̊֐gp鎖͂܂B}
{ hWindow : _CAÕEBhEnh }
{ uMsg    : eCxgƂɃ_CAOM郁bZ[W }
{ lp      : uMsg ɉă_CAOMl }
{ lpData  : SelectFolder() 瑗ꂽǉ }
{ ̃R[obN֐͏ 0 Ԃ܂B}

function BrowseCallBackProc(hWindow: HWND; uMsg: UINT;
                            lp: LPARAM; lpData: LPARAM):Integer; stdcall;
var
  PBFFM: PBFFMore;
  R: TRect;
  X, Y: Integer;
  W, H: Integer;
begin
  case uMsg of
    BFFM_INITIALIZED:
    begin
      { _CAO\ׂ̈̒ǉ擾B}
      PBFFM := PBFFMore(lpData);

      { ItH_ݒ肷B}
      if lstrlen(PBFFM^.InitPath) > 2 then
        SendMessage(hWindow, BFFM_SETSELECTION, 1, LPARAM(PBFFM^.InitPath));

      { \ʒuݒ肷B}
      X := PBFFM^.Left;
      Y := PBFFM^.Top;
      if (X < 0) or (Y < 0) then // ̏ꍇ́Aʒɕ\܂B
      begin
        GetWindowRect(hWindow, R);
        W := R.Right - R.Left + 1;
        H := R.Bottom - R.Top + 1;
        X := (GetSystemMetrics(SM_CXSCREEN) - W) div 2;
        Y := (GetSystemMetrics(SM_CYSCREEN) - H) div 2;
      end;
      SetWindowPos(hWindow, 0, X, Y, 0, 0, SWP_NOSIZE or SWP_NOZORDER);
    end;
  end;
  Result := 0; //  0 ԂB
end;

{ TFileTime ^̒l Delphi  TDateTime ^ɕϊ֐łB}
{ ϊɐꍇ́ATrue sꍇFalse Ԃ܂B}

function FileTimeToDateTime(FTime: TFileTime; var DTime: TDateTime): Boolean;
var
  STime: TSystemTime;
  TempTime: TFileTime;
begin
  Result := True;
  try
    // FileTime `GMT(E莞)nɂ킹B
    FileTimeToLocalFileTime(FTime, TempTime);
    // FileTime ` SystemTime `ɂB
    FileTimeToSystemTime(TempTime, STime);
    // SystemTime ` Delphi  TDateTime `ɕϊB
    DTime := SystemTimeToDateTime(STime);
  except
    Result := False;
  end;
end;

{ TDateTime ^̒l Delphi  TFileTime ^ɕϊ֐łB}
{ ϊɐꍇ́ATrue sꍇFalse Ԃ܂B}

function DateTimeToFileTime(DTime: TDateTime; var FTime: TFileTime): Boolean;
var
  STime: TSystemTime;
  LocalTime: TFileTime;
begin
  Result := True;
  try
    // TDateTimeSystemTimeɕϊ
    DateTimeToSystemTime(DTime, STime);
    // SystemTimenFileTimeɕϊ
    SystemTimeToFileTime(STime, LocalTime);
    // Ōɒn̓GMT(E莞)ɕϊ
    LocalFileTimeToFileTime(LocalTime, FTime);
  except
    Result := False;
  end;
end;

{ t@CtH_̓tύX֐łB}
{  s̎g͕ύXo܂B}
{ FileName: String; // ύXt@C܂̓tH_
{ Stamp: Integer; // ύX̎ނňȉ̒lI܂B
{ ftCreationTime   = 1; // t@C쐬ύX }
{ ftLastAccessTime = 2; // t@C̃ANZXύX }
{ ftLastWriteTime  = 4; // t@CXVύX }
{ DTime: TDateTime; // ݒ }
{ ύXɐꍇ́ATrue sꍇFalse Ԃ܂B}

function SetTimeStamp(FileName: String; Stamp: Integer; DTime: TDateTime): Boolean;
var
  Handle: THandle;
  SetTime: TFileTime;
  ctp, atp, wtp: Pointer;
begin
  ctp := Nil; atp := Nil; wtp := Nil;
  Handle := 0;
  try
    Handle := CreateFile(PChar(FileName),
                         GENERIC_WRITE,
                         FILE_SHARE_READ,
                         Nil,
                         OPEN_EXISTING,
                         FILE_FLAG_BACKUP_SEMANTICS,
                         0);

    if Handle = INVALID_HANDLE_VALUE then
      Result := False
    else
    begin
      Result := DateTimeToFileTime(DTime, SetTime);
      if Result = True then
      begin
        if Stamp = ftCreationTime then
          ctp := Addr(SetTime)
        else if Stamp = ftLastAccessTime then
          atp := Addr(SetTime)
        else if Stamp = ftLastWriteTime then
          wtp := Addr(SetTime);
        // tύXB
        if SetFileTime(Handle, ctp, atp, wtp) = False then
          Result := False;
      end;
    end;
  finally
    CloseHandle(Handle);
  end;
end;

{ gq̊֘AtĂ邩ǂԂ֐łB}
{ Extension : gq }
{ ֘AtĂ True AĂȂ False Ԃ܂B}

function AssociateExists(Extension: String): Boolean;
var
  Reg: TRegistry;
begin
  Result := False;
  if (Extension = '') or (Extension[1] <> '.') then
    Exit;

  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;

    if Reg.OpenKey('\' + Extension, False) then // ֘AtȂĂB
      Result := True;
    Reg.CloseKey;
  finally
    Reg.Free;
  end;
end;

{ ֘AtĂgq̊gq擾֐łB}
{ Extension : gq }
{ R : gq }
{ gq̊֘AtĂꍇ True AĂȂꍇ }
{ False Ԃ܂B}

function AssociateGet(Extension: String; var R: TExtensionRec): Boolean;
var
  Reg: TRegistry;
begin
  Result := False;
  if not AssociateExists(Extension) then
    Exit;

  R.Extension := Extension;
  R.ExtensionKey := '';
  R.ExtensionName := '';
  R.DefaultIcon := '';
  R.Command := '';

  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;

    if Reg.OpenKey('\' + R.Extension, False) then
    begin
      R.ExtensionKey := Reg.ReadString('');
      Reg.CloseKey
    end;

    if (R.ExtensionKey <> '') and Reg.OpenKey('\' + R.ExtensionKey, False) then
    begin
      R.ExtensionName := Reg.ReadString('');
      Reg.CloseKey
    end;

    if (R.ExtensionKey <> '') and Reg.OpenKey('\' + R.ExtensionKey + '\DefaultIcon', False) then
    begin
      R.DefaultIcon := Reg.ReadString('');
      Reg.CloseKey
    end;

    if (R.ExtensionKey <> '') and Reg.OpenKey('\' + R.ExtensionKey + '\shell\open\command', False) then
    begin
      R.Command := Reg.ReadString('');
      Reg.CloseKey
    end;
  finally
    Reg.Free;
  end;
  Result := True;
end;

{ gq̊֘AtVɍsȂׂ̊֐łB}
{ R : gq }
{ łɊ֘AtȂĂꍇ͉܂B̏ꍇ }
{ ֘AtɎsꍇ False Ԃ܂B֘Atɐ }
{ ꍇ True Ԃ܂B}

function AssociateMake(R: TExtensionRec): Boolean;
var
  Reg: TRegistry;
begin
  Result := False;
  if (R.Extension = '') or (R.Extension[1] <> '.') or (R.ExtensionKey = '') or
     (R.Command = '') or AssociateExists(R.Extension) then
    Exit;

  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;

    Reg.OpenKey('\' + R.Extension, True);
    Reg.WriteString('', R.ExtensionKey);
    Reg.CloseKey;

    Reg.OpenKey('\' + R.ExtensionKey, True);
    if R.ExtensionName <> '' then
      Reg.WriteString('', R.ExtensionName);
    Reg.CloseKey;

    Reg.OpenKey('\' + R.ExtensionKey + '\DefaultIcon', True);
    if R.DefaultIcon <> '' then
      Reg.WriteString('', R.DefaultIcon);
    Reg.CloseKey;

    Reg.OpenKey('\' + R.ExtensionKey + '\shell\open\command', True);
    Reg.WriteString('', R.Command);
    Reg.CloseKey;

    SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_FLUSH, Nil, Nil);
    Result := True;
  finally
    Reg.Free;
  end;
end;

{ gq̊֘At̓eύX֐łB}
{ R : gq }
{ R  Extension ȊÕoɂ '%' w肷鎖o܂B}
{ '%' w肵óAύXȂƂӖ܂Bo }
{ '%' wốAgq֘Ał͂ AssociateChange ֐łB}
{ ֘AtĂȂꍇύXɎsꍇ False Ԃ܂B}
{ ύXɐꍇ True Ԃ܂B}

function AssociateChange(R: TExtensionRec): Boolean;
var
  Reg: TRegistry;
  RO: TExtensionRec;
begin
  Result := False;
  if (not AssociateGet(R.Extension, RO)) or // ύXȌ RO Ɏ擾B
     (R.ExtensionKey = '') or (R.Command = '') then
    Exit;

  { '%' w肵óAύX܂B}
  if R.ExtensionKey = '%' then R.ExtensionKey := RO.ExtensionKey;
  if R.ExtensionName = '%' then R.ExtensionName := RO.ExtensionName;
  if R.DefaultIcon = '%' then R.DefaultIcon := RO.DefaultIcon;
  if R.Command = '%' then R.Command := RO.Command;

  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_CLASSES_ROOT;

    Reg.OpenKey('\' + R.Extension, True);
    Reg.WriteString('', R.ExtensionKey);
    Reg.CloseKey;

    if R.ExtensionKey <> RO.ExtensionKey then
      Reg.DeleteKey('\' + RO.ExtensionKey); // ExtensionKey ύXꍇ

    Reg.OpenKey('\' + R.ExtensionKey, True);
    Reg.WriteString('', R.ExtensionName);
    Reg.CloseKey;

    Reg.OpenKey('\' + R.ExtensionKey + '\DefaultIcon', True);
    Reg.WriteString('', R.DefaultIcon);
    Reg.CloseKey;

    Reg.OpenKey('\' + R.ExtensionKey + '\shell\open\command', True);
    Reg.WriteString('', R.Command);
    Reg.CloseKey;

    SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_FLUSH, Nil, Nil);
    Result := True;
  finally
    Reg.Free;
  end;
end;

{ gq̊֘At폜֐łB}
{ Extension : gq }
{ ֘AtĂȂꍇ폜Ɏsꍇ False Ԃ܂B}
{ 폜ɐꍇ True Ԃ܂B}

function AssociateDelete(Extension: String): Boolean;
var
  R: TExtensionRec;
  r1, r2: Boolean;
begin
  Result := True;
  if not AssociateGet(Extension, R) then // gq R Ɏ擾B
  begin
    Result := False;
    Exit;
  end;

  r1 := RegDeleteKeyR(HKEY_CLASSES_ROOT, '\' + R.Extension);
  r2 := RegDeleteKeyR(HKEY_CLASSES_ROOT, '\' + R.ExtensionKey);

  SHChangeNotify(SHCNE_ASSOCCHANGED, SHCNF_FLUSH, Nil, Nil);

  if (r1 = False) or ((R.ExtensionKey <> '') and (r2 = False)) then
    Result := False;
end;

{ [gL[ Root ̃WXgL[ Key ̊֘Af[^TuL[ }
{ Ƃɍ폜֐łB}
{ Root : [gL[ }
{ Key  : 폜Ώۂ̃WXgL[ }
{ ̊֐́ATuL[͍ċAĂяogč폜Ă܂B폜ɐ }
{  True As False Ԃ܂B}

function RegDeleteKeyR(Root: HKEY; Key: String): Boolean;
var
  i: Integer;
  KeyNames: TStringList;
  ValueNames: TStringList;
  Reg: TRegistry;
begin
  Result := False;
  if Key = '' then
    Exit;

  Reg := TRegistry.Create;
  KeyNames := TStringList.Create;
  ValueNames := TStringList.Create;
  try
    Reg.RootKey := Root;

    if Reg.OpenKey(Key, False) then
    begin
      Reg.GetKeyNames(KeyNames); // Key ̃TuL[ KeyNames Ɏ擾B
      Reg.CloseKey;
      for i := 0 to KeyNames.Count - 1 do
        RegDeleteKeyR(Root, Key + '\' + KeyNames[i]); // TuL[ċAĂяogč폜B
    end;

    if Reg.OpenKey(Key, False) then
    begin
      Reg.GetValueNames(ValueNames); // Key ̊֘Af[^ ValueNames Ɏ擾B
      for i := 0 to ValueNames.Count - 1 do
        Reg.DeleteValue(ValueNames[i]); // ֘Af[^폜B
      Reg.CloseKey;
    end;

    if Reg.DeleteKey(Key) then
      Result := True;
  finally
    ValueNames.Free;
    KeyNames.Free;
    Reg.Free;
  end;
end;

{ Windows W̒t@C̃pX MS-DOS W8.3`̒Zt@C }
{ ̃pXɕϊ֐łBLongName ̓tpXw肵ĉB}
{ LongName  : ϊO̒t@C̃pX }
{ ShortName : ϊ̒Zt@C̃pX }
{ ̒Zt@C̓t@CGNXv[Av Drag&Drop  }
{ ꍇgq̊֘AtȂĂt@CGNXv[J }
{ ꍇɌ鎖܂Bϊɐ True s False }
{ Ԃ܂B}

function LongNameToShortName(LongName: String; var ShortName: String): Boolean;
var
  i, OldMode: Integer;
  Rec: TSearchRec;
  L, S: String;
begin
  Result := False;
  L := LongName;
  if (Length(L) < 3) or (L[2] <> ':') or (L[3] <> '\') then
    Exit;

  S := Copy(L, 1, 3);
  OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  i := GetDriveType(PChar(S));
  SetErrorMode(OldMode);
  if i in [0, 1] then // pX̃hCus邢͎gpoȂꍇ
    Exit;

  S := '';
  while True do
  begin
    if Length(L) = 3 then
    begin
      ShortName := L + S;
      Result := True;
      Break;
    end;
    i := FindFirst(L, faAnyFile, Rec);
    if i = 0 then
    begin
      L := ExtractFileDir(L);
      if Rec.FindData.cAlternateFileName <> '' then
        S := Rec.FindData.cAlternateFileName + S
      else
        S := Rec.FindData.cFileName + S;
      if Length(L) > 3 then
        S := '\' + S;
    end;
    FindClose(Rec);
    if i <> 0 then // ݂Ȃt@CfBNg̏ꍇ
      Break;
  end;
end;

{ MS-DOS W8.3`̒Zt@C̃pX Windows W̒t@C }
{ ̃pXɕϊ֐łBShortName ̓tpXw肵ĉB}
{ ShortName : ϊO̒Zt@C̃pX }
{ LongName  : ϊ̒t@C̃pX }
{ ̒Zt@C̓t@CGNXv[Av Drag&Drop  }
{ ꍇgq̊֘AtȂĂt@CGNXv[J }
{ ꍇɌ鎖܂Bϊɐ True s False }
{ Ԃ܂B}

function ShortNameToLongName(ShortName: String; var LongName: String): Boolean;
var
  i, OldMode: Integer;
  Rec: TSearchRec;
  S, L: String;
begin
  Result := False;
  S := ShortName;
  if (Length(S) < 3) or (S[2] <> ':') or (S[3] <> '\') then
    Exit;

  L := Copy(S, 1, 3);
  OldMode := SetErrorMode(SEM_FAILCRITICALERRORS);
  i := GetDriveType(PChar(L));
  SetErrorMode(OldMode);
  if i in [0, 1] then // pX̃hCus邢͎gpoȂꍇ
    Exit;

  L := '';
  while True do
  begin
    if Length(S) = 3 then
    begin
      LongName := S + L;
      Result := True;
      Break;
    end;
    i := FindFirst(S, faAnyFile, Rec);
    if i = 0 then
    begin
      S := ExtractFileDir(S);
      L := Rec.FindData.cFileName + L;
      if Length(S) > 3 then
        L := '\' + L;
    end;
    FindClose(Rec);
    if i <> 0 then // ݂Ȃt@CfBNg̏ꍇ
      Break;
  end;
end;

{ TParameter }

constructor TParameter.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FParams := TStringList.Create;
  FParams.Duplicates := dupIgnore;
  FDir := '';       // p[^ۑt@CutH_
  FFileName := '';  // p[^ۑt@C
  FExeName := '';   // AvP[V̎st@C
  FDigit := 15;     // _^ VExtends[] ̗L(3 ` 18)
end;

destructor TParameter.Destroy;
begin
  FParams.Free;
  inherited Destroy;
end;

function TParameter.Add(const S: String): Integer;
begin
  Result := FParams.Add(S);
end;

procedure TParameter.Clear;
begin
  FParams.Clear;
end;

{ ExeName ̃V[gJbg Windows ̓tH_ɍ쐬֐łB}
{ nFolder : Windows ̓tH_\킷 CSIDL l }
{ LinkName : V[gJbgɕt閼O }
{  CSIDL lɂ́Aȉ̗lȂ̂܂B}
{ CSIDL_DESKTOP : fXNgbv }
{ CSIDL_PROGRAMS : vO }
{ CSIDL_STARTUP : X^[gAbv }
{ CSIDL_PERSONAL : }ChLg }
{ CSIDL_FOVORITES : Cɓ }
{ CSIDL_COMMON_PROGRAMS : vO(S[U[) }
{ CSIDL_COMMON_STARTUP : X^[gAbv(S[U[) }
{ CSIDL_COMMON_FAVORITES : Cɓ(S[U[) }
{ ȂACSIDL_* ̊e萔gpꍇ́Auses ߂ ShlObj KvłB}
{ V[gJbg̍쐬ɐ True As False Ԃ܂B}

function TParameter.CreateShortCut(nFolder: Integer; LinkName: String): Boolean;
begin
  Result := CreateShortCutLink(ExeName, GetSpecialFolder(nFolder), LinkName);
  if Result = True then
    SendMessage(HWND_BROADCAST, WM_SETTINGCHANGE, 0, 0);
end;

procedure TParameter.Delete(Index: Integer);
begin
  FParams.Delete(Index);
end;

{ Windows ̓tH_ɍ쐬ꂽV[gJbg폜֐łB}
{ nFolder : Windows ̓tH_\킷 CSIDL l }
{ LinkName : V[gJbgɕtꂽO }
{  CSIDL lɂ́Aȉ̗lȂ̂܂B}
{ CSIDL_DESKTOP : fXNgbv }
{ CSIDL_PROGRAMS : vO }
{ CSIDL_STARTUP : X^[gAbv }
{ CSIDL_PERSONAL : }ChLg }
{ CSIDL_FOVORITES : Cɓ }
{ CSIDL_COMMON_PROGRAMS : vO(S[U[) }
{ CSIDL_COMMON_STARTUP : X^[gAbv(S[U[) }
{ CSIDL_COMMON_FAVORITES : Cɓ(S[U[) }
{ ȂACSIDL_* ̊e萔gpꍇ́Auses ߂ ShlObj KvłB}
{ V[gJbg̍폜ɐ True As False Ԃ܂B}

function TParameter.DeleteShortCut(nFolder: Integer; LinkName: String): Boolean;
begin
  Result := DeleteShortCutLink(GetSpecialFolder(nFolder), LinkName);
  if Result = True then
    SendMessage(HWND_BROADCAST, WM_SETTINGCHANGE, 0, 0);
end;

function TParameter.GetCount: Integer;
begin
  Result := FParams.Count;
end;

function TParameter.GetDigit: Integer;
begin
  Result := FDigit;;
end;

function TParameter.GetDir: String;
begin
  Result := FDir;
end;

function TParameter.GetExeName: String;
begin
  Result := FExeName;
end;

function TParameter.GetFileName: String;
begin
  Result := FFileName;
end;

function TParameter.GetFullName: String;
begin
  Result := '';
  if (Dir = '') or (FileName = '') then
    Exit;
  Result := Dir;
  if Result[Length(Result)] <> '\' then
    Result := Result + '\';
  Result := Result + FileName;
end;

function TParameter.GetParam(Index: Integer): String;
begin
  if (Index < 0) or (Index >= FParams.Count) then
    raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d',
     [Index, 0, FParams.Count - 1]);
  Result := FParams.Strings[Index];
end;

function TParameter.GetVBool(const Name: String): Boolean;
var
  S: String;
begin
  S := VStrings[Name];
  if S = 'True' then
    Result := True
  else if S = 'False' then
    Result := False
  else
    raise EValueName.CreateFmt('Value of %s ''%s'' is not Boolean Type.',
     [Name, S]);
end;

function TParameter.GetVExtend(const Name: String): Extended;
begin
  Result := StrToFloat(VStrings[Name]);
end;

function TParameter.GetVFontStyle(const Name: String): TFontStyles;
var
  S: String;
begin
  Result := []; // W
  S := VStrings[Name];
  if Pos('fsBold', S) <> 0 then
    Include(Result, fsBold);
  if Pos('fsItalic', S) <> 0 then
    Include(Result, fsItalic);
  if Pos('fsUnderline', S) <> 0 then
    Include(Result, fsUnderline);
  if Pos('fsStrikeout', S) <> 0 then
    Include(Result, fsStrikeout);
end;

function TParameter.GetVInteger(const Name: String): Integer;
begin
  Result := StrToInt(VStrings[Name]);
end;

function TParameter.GetVString(const Name: String): String;
begin
  Result := FParams.Values[Name];
  if Result = #26 then
    Result := '' // 󕶎̏ꍇAڈƂ #26 ꕶݒ肵ĂB
  else if Result = '' then
    raise EValueName.CreateFmt('Name ''%s'' is not found in parameters.',
     [Name]);
end;

function TParameter.IndexOfName(const Name: String): Integer;
begin
  Result := FParams.IndexOfName(Name);
end;

procedure TParameter.Init;
begin
  if FExeName = '' then
  begin
    if Assigned(Application) then
      FExeName := Application.ExeName; // Default
  end;

  if FDir = '' then
    FDir := ExtractFileDir(FExeName);

  if FFileName = '' then
    FFileName := ChangeFileExt(ExtractFileName(FExeName), '') + '.ini';

  LoadFromFile;
end;

procedure TParameter.Insert(Index: Integer; const S: String);
begin
  FParams.Insert(Index, S);
end;

procedure TParameter.LoadFromFile;
begin
  if FileExists(FullName) then
    FParams.LoadFromFile(FullName);
end;

procedure TParameter.SaveToFile;
begin
  if FullName <> '' then
    FParams.SaveToFile(FullName);
end;

procedure TParameter.SetDigit(const Value: Integer);
begin
  if Value in [3..18] then
    FDigit := Value;
end;

procedure TParameter.SetDir(const Value: String);
begin
  FDir := Value;
end;

procedure TParameter.SetExeName(const Value: String);
begin
  FExeName := Value;
end;

procedure TParameter.SetFileName(const Value: String);
begin
  FFileName := Value;
end;

procedure TParameter.SetParam(Index: Integer; const Value: String);
begin
  if (Index < 0) or (Index >= FParams.Count) then
    raise ERangeError.CreateFmt('%d is not within the valid range of %d..%d',
     [Index, 0, FParams.Count - 1]);
  FParams.Strings[Index] := Value;
end;

procedure TParameter.SetVBool(const Name: String; Value: Boolean);
begin
  if Value = True then
    VStrings[Name] := 'True'
  else
    VStrings[Name] := 'False';
end;

procedure TParameter.SetVExtend(const Name: String; Value: Extended);
begin
  VStrings[Name] := FloatToStrF(Value, ffGeneral, FDigit, 0); // Digit = 3 ` 18
  // VStrings[Name] := Format('%.*g', [FDigit, Value]); ƂĂʂB 
end;

procedure TParameter.SetVFontStyle(const Name: String; Value: TFontStyles);
var
  S: String;
begin
  S := '[';
  if fsBold in Value then
    S := S + 'fsBold';
  if fsItalic in Value then
  begin
    if Length(S) > 1 then
      S := S + ',';
    S := S + 'fsItalic';
  end;
  if fsUnderline in Value then
  begin
    if Length(S) > 1 then
      S := S + ',';
    S := S + 'fsUnderline';
  end;
  if fsStrikeOut in Value then
  begin
    if Length(S) > 1 then
      S := S + ',';
    S := S + 'fsStrikeOut';
  end;
  S := S + ']';
  VStrings[Name] := S;
end;

procedure TParameter.SetVInteger(const Name: String; Value: Integer);
begin
  VStrings[Name] := IntToStr(Value);
end;

procedure TParameter.SetVString(const Name, Value: String);
begin
  if Value = '' then // 󕶎̏ꍇAڈƂ #26 ꕶݒ肷B
    FParams.Values[Name] := #26
  else
    FParams.Values[Name] := Value;
end;

end.

